#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "ampire_cfg.h"
#include "fwtypes.h"

#include "scm_reg.h"
#include "nagpio.h"

#include "ampire_utils.h"
#include "ampire_graphics.h"



//*************************************************************// 
/**************Don't need to change the bellow macro**************/ 
 
#if LCD_DCLK== 1 
  #define R41       20 
  #define R42    	1 
  #define R10_B10  	0 
#endif  
 
#if LCD_DCLK== 2   
  #define R41       10 
  #define R42    	1 
  #define R10_B10  	0 
#endif  
 
#if LCD_DCLK== 3   
  #define R41       6 
  #define R42    	1 
  #define R10_B10  	0 
#endif  
  
#if LCD_DCLK== 4   
  #define R41       5 
  #define R42    	1 
  #define R10_B10  	0 
#endif   
 
#if LCD_DCLK== 5   
  #define R41       1 
  #define R42    	1 
  #define R10_B10  	2 
#endif    
 
#if LCD_DCLK== 6   
  #define R41       3 
  #define R42    	4 
  #define R10_B10  	2 
#endif    
 
#if LCD_DCLK== 7   
  #define R41       4 
  #define R42    	3  
  #define R10_B10  	1 
#endif    
 
#if LCD_DCLK== 8   
  #define R41       12 
  #define R42    	10 
  #define R10_B10  	1 
#endif    
 
#if LCD_DCLK== 10       
  #define R41       1 
  #define R42    	1 
  #define R10_B10  	1 
#endif    
 
#if LCD_DCLK== 12       
  #define R41       5 
  #define R42    	6 
  #define R10_B10  	1 
#endif    
 
  
#if LCD_DCLK== 15        
  #define R41       2 
  #define R42    	3 
  #define R10_B10  	1 
#endif  

#if LCD_DCLK== 18   
  #define R41       10 
  #define R42    	9 
  #define R10_B10  	0 
#endif   
 
#if LCD_DCLK== 20   
  #define R41       1 
  #define R42    	2 
  #define R10_B10  	1 
#endif 

#if LCD_DCLK== 22   
  #define R41       10 
  #define R42    	11 
  #define R10_B10  	0 
#endif 

#if LCD_DCLK== 25   
  #define R41       4 
  #define R42    	5 
  #define R10_B10  	0 
#endif 

#if LCD_DCLK== 30   
  #define R41       2 
  #define R42    	3 
  #define R10_B10  	0 
#endif 

#if LCD_DCLK== 40   
  #define R41       1 
  #define R42    	2 
  #define R10_B10  	0 
#endif

#if LCD_DCLK== 60   
  #define R41       1 
  #define R42    	6 
  #define R10_B10  	1 
#endif

#if LCD_DCLK== 80   
  #define R41       1 
  #define R42    	4 
  #define R10_B10  	0 
#endif

struct init_array{
	unsigned char index;
	unsigned int delay;
	unsigned short value;
};


#ifdef  Landscap 
	struct init_array init_data[] =
	{ 
		{0x40,10,0x12},  
	 	{0x41,10,R41},                     
		{0x42,10,R42},  
		
		//{0x00,10,0x00},
		//{0x01,10,0x00},                   
		//{0x02,10,0x01},                   
		//{0x03,10,0x3f},                   
		//{0x04,10,0x00},                   
		//{0x05,10,0x00},                   
		//{0x06,10,0x00},                   
		//{0x07,10,0xef},                   
		
	 	{0x08,10,(uint8)(SCREEN_WIDTH>>8)},   
	 	{0x09,10,(uint8)(SCREEN_WIDTH)},     
	 	{0x0a,10,0x00},        
	 	{0x0b,10,0x00},        
	 	{0x0c,10,0x00},        
	 	{0x10,10,0x0C|R10_B10},     
	 	//{0x10,10,0x0C|0x02},       
	 	{0x11,10,0x05},       
	 	{0x12,10,0x00},        
	 	{0x13,10,0x00},        
	 	{0x14,10,(uint8)(H_Sync_Pluse_Wide>>8)},     
	 	{0x15,10,(uint8)(H_Sync_Pluse_Wide)},   
	 	{0x16,10,(uint8)(H_Sync_to_DE>>8)},     
	 	{0x17,10,(uint8)(H_Sync_to_DE)},   
	 	{0x18,10,(uint8)(SCREEN_WIDTH>>8)},   
	 	{0x19,10,(uint8)(SCREEN_WIDTH)},   
	 	{0x1a,10,(uint8)(H_Sync_total>>8)},     
	 	{0x1b,10,(uint8)(H_Sync_total)},    
	 	{0x1c,10,0x00},        
	 	{0x1d,10,0x00}, 
	 	{0x1e,10,(uint8)(V_Sync_Pluse_Wide>>8)},     
	 	{0x1f,10,(uint8)(V_Sync_Pluse_Wide)},   
	 	{0x20,10,(uint8)(V_Sync_to_DE>>8)},     
	 	{0x21,10,(uint8)(V_Sync_to_DE)},  
		{0x22,10,(uint8)(SCREEN_HEIGHT>>8)},   
	 	{0x23,10,(uint8)(SCREEN_HEIGHT)}, 
	 	{0x24,10,(uint8)(V_Sync_total>>8)},     
	 	{0x25,10,(uint8)(V_Sync_total)}, 
	 	{0x26,10,0x00},        
		{0x27,10,0x00},        
		{0x28,10,0x00}, 
		//{0x29,10,0x01},  		
		{0x2a,10,0x3f},	//R (test)
		{0x2b,10,0x3f},	//G (test)
		{0x2c,10,0x3f},	//B (test)	 	 
		{0x2d,10,LCD_DCLK_Latch|0x08}, 
		// [7:4] Reserved 
		// [3] Output pin X_DCON level control   
	    // [2] Output clock inversion    0: Normal 1: Inverse 
	    // [1:0] Image rotate   
	    //   00: 0  01: 90  10: 270 11: 180 
		{0x30,10,0x00}, 
	 	{0x31,10,0x00}, 
	 	{0x32,10,0x00}, 
	 	{0x33,10,0x00}, 
	 	{0x34,10,(uint8)(SCREEN_WIDTH>>8)},   
	 	{0x35,10,(uint8)(SCREEN_WIDTH)},   
		{0x36,10,(uint8)((2*SCREEN_HEIGHT)>>8)},   
	 	{0x37,10,(uint8)(2*SCREEN_HEIGHT)}, 
	 	{0x29,10,0x01}, 
		{0,0,0},
	}; 
#endif 
 
#ifdef  Portrait 
	struct init_array init_data[] =
	 
	{ 
		 {0x40,10,0x12},  
		 {0x41,10,R41},                     
		 {0x42,10,R42},                    
		 {0x08,10,(uint8)(SCREEN_WIDTH>>8)},   
		 {0x09,10,(uint8)(SCREEN_WIDTH)},     
		 {0x0a,10,0x00},        
		 {0x0b,10,0x00},        
		 {0x0c,10,0x00},        
		 {0x10,10,0x0C|R10_B10},     
		 //{0x10,10,0x0C|0x02},       
		 {0x11,10,0x05},       
		 {0x12,10,0x00},        
		 {0x13,10,0x00},        
		 {0x14,10,(uint8)(H_Sync_Pluse_Wide>>8)},      
		 {0x15,10,(uint8)(H_Sync_Pluse_Wide)},   
		 {0x16,10,(uint8)(H_Sync_to_DE>>8)},     
		 {0x17,10,(uint8)(H_Sync_to_DE)},   
		 {0x18,10,(uint8)(SCREEN_HEIGHT>>8)},   
		 {0x19,10,(uint8)(SCREEN_HEIGHT)},   
		 {0x1a,10,(uint8)(H_Sync_total>>8)},     
		 {0x1b,10,(uint8)(H_Sync_total)},    
		 {0x1c,10,0x00},        
		 {0x1d,10,0x00}, 
		 {0x1e,10,(uint8)(V_Sync_Pluse_Wide>>8)},     
		 {0x1f,10,(uint8)(V_Sync_Pluse_Wide)},   
		 {0x20,10,(uint8)(V_Sync_to_DE>>8)},     
		 {0x21,10,(uint8)(V_Sync_to_DE)},  
		 {0x22,10,(uint8)(SCREEN_WIDTH>>8)},   
		 {0x23,10,(uint8)(SCREEN_WIDTH)}, 
		 {0x24,10,(uint8)(V_Sync_total>>8)},     
		 {0x25,10,(uint8)(V_Sync_total)}, 
		 {0x26,10,0x00},        
		 {0x27,10,0x00},        
		 {0x28,10,0x00}, 
		 {0x29,10,0x01}, 
		 {0x2a,10,0x00},	//R (test)
		 {0x2b,10,0x00},	//G (test)
		 {0x2c,10,0x00},	//B (test)	 
		 {0x2d,10,LCD_DCLK_Latch|0x08|0x01}, 
		 // [7:4] Reserved 
		 // [3] Output pin X_DCON level control   
		 // [2] Output clock inversion    0: Normal 1: Inverse 
		 // [1:0] Image rotate   
		 //   00: 0  01: 90  10: 270 11: 180 		 
		 {0x30,10,0x00}, 
		 {0x31,10,0x00}, 
		 {0x32,10,0x00}, 
		 {0x33,10,0x00}, 
		 {0x34,10,(uint8)(SCREEN_WIDTH>>8)},   
		 {0x35,10,(uint8)(SCREEN_WIDTH)},   
		 {0x36,10,(uint8)((2*SCREEN_HEIGHT)>>8)},   
		 {0x37,10,(uint8)(2*SCREEN_HEIGHT)},
		 {0,0,0},
	};
#endif 	



void amp_reset(void)			
{	
	naGpioSetOutput(AMP_DEFAULT_RESET_PIN, 0);
	tx_thread_sleep(NS_MILLISECONDS_TO_TICKS(100));
	naGpioSetOutput(AMP_DEFAULT_RESET_PIN, 1);
	tx_thread_sleep(NS_MILLISECONDS_TO_TICKS(100));
}
 
int lcd_rotation;

 
void amp_init(void)
{
 	int i,errors;
 	unsigned short read;

	naGpioSetOutput(AMP_RS_PIN, 1);		//Initialize RS line (high)
	
	amp_reset();

    
/*
 * NOT USED EXTENDED WAIT REGISTERS
    narm_write_reg(NA_MPMC_STATIC_EXTENDED_WAIT,
                   NA_MPMC_STATIC_EXTENDED_WAIT_ADDR,
                   EXTW, LCD_WAIT_STATES);
*/
		
	i=0;
   	errors = 0;
   	
	printf( "Write Registers:\n");
	while(	init_data[i].index )
    {
    	write_cmd_data( init_data[i].index, init_data[i].value);

    	#ifdef LCD_VERIFY_CFG
			printf( "Write reg 0x%02X\tval: 0x%02X\n",init_data[i].index, init_data[i].value);

			write_cmd(init_data[i].index);
			read = read_data();

	      	if(init_data[i].value != read && errors<3){
    	  		printf("Verification error on reg#0x%02X. Trying again!\n", init_data[i].index );      	
      			errors++;
	      	}
      		else{
      			if(errors==3)
      				printf( "Write reg 0x%02X fails. Writed 0x%02X, read 0x%02X\n",
      					init_data[i].index, init_data[i].value, read);	
				i++;
				errors = 0;
      		}
      	#endif
      	
      	#ifndef LCD_VERIFY_CFG
      		//if(init_data[i].delay != 0)
      		//	tx_thread_sleep((NABspTicksPerSecond / 1000) * init_data[i].delay);
      		i++;      		
      	#endif
	}
		
	ampire_init();//initialize mutex, etc.	
	lcd_rotation = ROT_0;
	
		
	amp_fillscreen(0xFFFF);
	

	AMP_BACKLIGHT_ON;

	return;
}




void amp_rotate(lcd_rotate_t deg)
{
    unsigned short data;

    write_cmd( 0x2D );
    data = read_data();
	
	data &= 0xFFFC;
	data |= deg;

    write_cmd_data(0x2D, data);

	lcd_rotation = deg;
	
    return;
}
/*
//Not implemented by Ampire hardware
void amp_enableController(int value)
{
    unsigned short data;

    write_cmd( 0x2D );
    data = read_data();

    if(value)
        data |= 0x0008;
    else
        data &= 0xFFF7;

    write_cmd_data(0x2D, data);

    return;
}
*/

